import { OriginalRelation, DielAst } from "../../parser/dielAstTypes";
export declare function NormalizeConstraintsForSingleOriginalRelation(r: OriginalRelation): void;
/**
 * constraints can be created either on the column or on the table
 * we will move all to the table level for easier checking
 *   but i think SQL syntax requires some to be written in column leve, e.g., not null
 *   however primary key can be in both positions (presumably because it can take multiple columns)
 *
 * the function will walk through the original tables and move the column level
 *   constraints to relation constraints
 *   and maybe label the field  as "derived"
 *
 * see https://www.sqlite.org/syntax/column-constraint.html
 *     and https://www.sqlite.org/syntax/table-constraint.html
 *
 * we have augmented it so that it could work with views as well
 */
export declare function NormalizeConstraints(ast: DielAst): void;
//# sourceMappingURL=normalizeConstraints.d.ts.map