"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dielAstTypes_1 = require("./dielAstTypes");
const misc_1 = require("antlr4ts/misc");
function parseColumnType(str) {
    switch (str.toLowerCase()) {
        case "number":
        case "integer":
        case "int":
        case "real":
            return dielAstTypes_1.DielDataType.Number;
        case "string":
        case "text":
            return dielAstTypes_1.DielDataType.String;
        case "boolean":
            return dielAstTypes_1.DielDataType.Boolean;
        case "datetime":
            return dielAstTypes_1.DielDataType.TimeStamp;
        default:
            throw new Error(`parseColumnType error, got ${str}`);
    }
}
exports.parseColumnType = parseColumnType;
function getCtxSourceCode(ctx) {
    if (ctx) {
        let a = ctx.start.startIndex;
        let b = ctx.stop.stopIndex;
        let interval = new misc_1.Interval(a, b);
        return ctx.start.inputStream.getText(interval);
    }
    return "";
}
exports.getCtxSourceCode = getCtxSourceCode;
//# sourceMappingURL=visitorHelper.js.map