import { DbType, DielRemoteAction, DielRemoteReply } from "./runtimeTypes";
import { DbIdType, LogicalTimestep } from "../parser/dielAstTypes";
declare type FinalMsgType = {
    buffer: any;
} | {
    message: string;
} | {
    sql: string;
} | {
    sql: string;
    message: {
        dbName: string;
    };
};
declare type FinalIdType = {
    remoteAction: DielRemoteAction;
    destinationDbId?: DbIdType;
    requestTimestep: LogicalTimestep;
};
export declare class ConnectionWrapper {
    resolves: Map<number, any>;
    rejects: Map<number, any>;
    globalMsgId: number;
    remoteType: DbType;
    connection: Worker | WebSocket;
    constructor(connection: Worker | WebSocket, remoteType: DbType);
    send(id: FinalIdType, msgToSend: FinalMsgType, isPromise: boolean): Promise<DielRemoteReply> | null;
    private sendNoPromise;
    setHandler(f: (msg: DielRemoteReply) => void): void;
}
export {};
//# sourceMappingURL=ConnectionWrapper.d.ts.map